unit Z1801;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls;

type
  TFormHra = class(TForm)
    MainMenu1: TMainMenu;
    Nastaven1: TMenuItem;
    StartHry1: TMenuItem;
    Konec1: TMenuItem;
    Topten1: TMenuItem;
    Panel1: TPanel;
    PlochaIMG: TImage;
    Kurzor: TShape;
    InfoLabel: TLabel;
    Hrac1Info: TLabel;
    Hrac2Info: TLabel;
    Label1: TLabel;
    procedure Konec1Click(Sender: TObject);
    procedure StartHry1Click(Sender: TObject);
    procedure PaintPlocha;
    procedure PlochaIMGMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure PolozZapalku(X,Y,natoceni:Byte);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Topten1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure zmenahrace;
    function KontrolaCtverce(x,y,natoceni:byte):boolean;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean); // kontroluje zda li hrac nedoplnil ctverec
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  Tpolicko = 0..2; // Typ jednoho policka
  Thrac = 1..2;
var
  FormHra: TFormHra;
  Plocha : Array [1..10, 1..10,1..2] OF Tpolicko; // Hrac plocha
  VelPlochaX,VelPlochaY:Byte; // Velikost hrac plochy
  Hrajese:Boolean; // Jestli hra be
  Hracaktivni:Thrac; // ktery hrac je na tahu
  Hrac1skore,Hrac2skore:Integer; // body hracu
implementation

uses Z1802, Z1803;

{$R *.DFM}


Procedure TFormHra.PaintPlocha; // nakresl hrac plochu
Var X,Y : Integer;
Begin
  for X := 0 to VelPlochaX do
  begin
   With PlochaIMG.Canvas Do
   Begin
    MoveTo(X*30,1);   // Nakresli vertikalni cary
    LineTo(X*30,VelPlochaY*30);
   end;
  end;
  for Y := 0 to VelPlochaY do
  begin
   With PlochaIMG.Canvas Do
   Begin
    MoveTo(1,Y*30);                  // nakresli vodorovne cary
    LineTo(VelPlochaX*30,Y*30);
   end;
  end;
end;

procedure TFormHra.Konec1Click(Sender: TObject);
begin
Close;
end;

procedure TFormHra.StartHry1Click(Sender: TObject);
begin
Seting.Show;
end;

function Tformhra.KontrolaCtverce(x,y,natoceni:byte):boolean; // kontroluje zda li hrac nedoplnil ctverec
Begin
 KontrolaCtverce:=false;
 if natoceni = 1 then // natoceni svisle
 begin
  If (plocha[X-1,Y,1] > 0)AND
     (plocha[X-1,Y,2] > 0)And  // ctverec pred
     (plocha[X-1,Y+1,2] > 0)and(x > 1)Then
  Begin
    With PlochaIMG.Canvas DO
    Begin
     brush.style:=BsClear;
     If hracaktivni = 1 then Pen.color:=Clred else Pen.color:=Clblue;
     Rectangle((X-1) * 30,Y * 30,X*30, Y*30+30);
    end;
     KontrolaCtverce:=true;
  end;
  If (plocha[X+1,Y,1] > 0)AND
     (plocha[X,Y,2] > 0)And  // ctverec za
     (plocha[X,Y+1,2] > 0)and(x < VelPlochaX)Then
  Begin
    With PlochaIMG.Canvas DO
    Begin
     brush.style:=BsClear;
     If hracaktivni = 1 then Pen.color:=Clred else Pen.color:=Clblue;
     Rectangle((X) * 30,Y * 30,(X+1)*30, Y*30+30);
    end;
   KontrolaCtverce:=true;
  end;
 end;
 if natoceni = 2 then // natoceni vodorovne
 begin
  If (plocha[X,Y-1,1] > 0)AND
     (plocha[X,Y-1,2] > 0)And  // ctverec pred
     (plocha[X+1,Y-1,1] > 0)and(y > 1)Then
  Begin
    With PlochaIMG.Canvas DO
    Begin
     brush.style:=BsClear;
     If hracaktivni = 1 then Pen.color:=Clred else Pen.color:=Clblue;
     Rectangle(X * 30,(Y-1) * 30,(X+1)*30, Y*30);
    end;
     KontrolaCtverce:=true;
  end;
  If (plocha[X,Y,1] > 0)AND
     (plocha[X,Y+1,2] > 0)And  // ctverec za
     (plocha[X+1,Y,1] > 0)and(y <VelplochaY )Then
  Begin
    With PlochaIMG.Canvas DO
    Begin
     brush.style:=BsClear;
     If hracaktivni = 1 then Pen.color:=Clred else Pen.color:=Clblue;
     Rectangle((X) * 30,(Y) * 30,X*30+30, (Y+1)*30);
    end;
     KontrolaCtverce:=true;
  end;
 end;
end;


Procedure TformHra.PolozZapalku(X,Y,natoceni:Byte); // vykresli zapalku
Begin
 With PlochaIMG.Canvas DO
 Begin
  case natoceni of
  1:   // kdyz je natoceni svisle
   Begin
     Pen.color:=CLolive;
     Pen.width:=3;
     MoveTo(X*30,Y*30+2);
     LineTo(X*30,Y*30+30-2);
     Pen.Color:=Clblack;
     Pen.width:=1;
     Plocha[X,Y,1]:=hracaktivni;
   end;
   2:   // kdyz je natoceni vodorovne
   Begin
     Pen.color:=CLolive;
     Pen.Width:=3;
     MoveTo(X*30+2,Y*30);
     LineTo(X*30+30-2,Y*30);
     Pen.Color:=Clblack;
     Pen.width:=1;
     Plocha[X,Y,2]:=hracaktivni;
   end;
  end;
 end;
 if    KontrolaCtverce(X,Y,natoceni) then
 if HracAktivni = 1 then
 Begin
  inc(Hrac1skore);
  Hrac1Info.Caption:='Hr 1 m '+IntToStr(Hrac1skore)+' bod';
  Zmenahrace;
 end
 else
 begin
  inc(Hrac2skore);
  Hrac2Info.Caption:='Hr 2 m '+IntToStr(Hrac2skore)+' bod';
    Zmenahrace;
 end;
end;

Procedure tformhra.ZmenaHrace;
Begin
 If hracaktivni = 1 then
 begin
  HracAktivni:=2;
  InfoLabel.Caption:='Hraje hr slo 2';
 end
 else
 begin
  HracAktivni:=1;
  InfoLabel.Caption:='Hraje hr slo 1';
 end;
end;


Procedure kontrolaKonceHry;
var X,Y,Natoceni:Byte;      // kontrola plnosti plochy
    plne:boolean;
Begin
 plne:=true;
 for y := 0 to VelPlochaY do
 begin
  for x := 0 to VelPlochaX do
  begin
   for natoceni := 1 to 2 do
   begin
     if (plocha[x,y,natoceni] = 0)and(not((x = VelPlochaX)and(natoceni = 2)))and
        (not((y = VelPlochay)and(natoceni = 1))) then
     begin
      plne:=false;
      exit;
     end;
   end;
  end;
 end;
 if plne then
 Begin
  hrajese:=false;
  if hrac1skore > hrac2skore then ShowMessage('Konec Hry!'+#13+' Vyhrl hr slo 1') else
   ShowMessage('Konec Hry!'+#13+' Vyhrl hr slo 2');
 end;
end;

procedure TFormHra.PlochaIMGMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var natoceni:byte;
    ZapalkaX,ZapalkaY:Byte;
begin
If Hrajese then
Begin
 If (X mod 30 > 5)and(X mod 30 < 25)and(Y mod 30 < 10) then // vodorovna zapalka nahore je?
 Begin
  natoceni:=2;
  ZapalkaX:=X div 30;
  ZapalkaY:= Y div 30;
  if plocha[(x div 30),y div 30,natoceni] <> 0 then exit;
 PolozZapalku(ZapalkaX,ZapalkaY,natoceni);
 ZmenaHrace;

 end
 else
 If (X mod 30 > 5)and(X mod 30 < 25)and(Y mod 30 > 10) then // vodorovna zapalka dole je?
 Begin
  natoceni:=2;
  ZapalkaX:=X div 30;
  ZapalkaY:= Y div 30+1;
  if plocha[x div 30,y div 30,natoceni] <> 0 then exit;
 PolozZapalku(ZapalkaX,ZapalkaY,natoceni);

 ZmenaHrace;

 end
 else
 If (X mod 30 < 5)and(Y mod 30 > 5)and(Y mod 30 <25) then  // svisla vlevo je ?
 Begin
  ZapalkaX:=X div 30;
  ZapalkaY:=Y div 30;
  natoceni:=1;
   if plocha[x div 30,y div 30,natoceni] <> 0 then exit;
 PolozZapalku(ZapalkaX,ZapalkaY,natoceni);

 ZmenaHrace;
 end
 else
 If (X mod 30 > 20)and(Y mod 30 > 5)and(Y mod 30 <25) then  // svisla vpravo  je ?
 Begin
  ZapalkaX:=X div 30+1;
  ZapalkaY:=Y div 30;
  natoceni:=1;
  if plocha[x div 30,y div 30,natoceni] <> 0 then exit;
   PolozZapalku(ZapalkaX,ZapalkaY,natoceni);
 ZmenaHrace;
 end;
  KontrolaKoncehry;
 end;
end;

procedure TFormHra.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Hrajese then
 Begin
  If (Key = 37)and(kurzor.width=3) then // sipka levo
  Begin
   Kurzor.left:=Kurzor.Left-30;
   If kurzor.left < 0 then // pres hranice plochy
   begin
    Kurzor.left:=VelPlochaX*30;
   end;
  end;
  If (Key = 37)and(kurzor.width=30) then // sipka levo
  Begin
   Kurzor.left:=Kurzor.Left-30;
   If kurzor.left < 0 then // pres hranice plochy
   begin
    Kurzor.left:=(VelPlochaX-1)*30;

   end;
  end;
  If Key = 39 then // sipka pravo
  Begin
   Kurzor.left:=Kurzor.Left+30;
   If kurzor.left > VelPlochaX*30+5 then Kurzor.left:=2; // pres hranice plochy

  end;
  If Key = 40 then // sipka dolu
  Begin
   Kurzor.top:=Kurzor.top+30;
   If kurzor.top > VelPlochaY*30+5 then Kurzor.top:=2; // pres hranice plochy

  end;
  If Key = 38 then // sipka nahoru
  Begin
   Kurzor.top:=Kurzor.top-30;
   If kurzor.top < 0 then Kurzor.top:=(VelPlochay-1)*30; // pres hranice plochy

  end;
  if key = 13 then // enter - rotace
  Begin
   if kurzor.width = 3 then  // je svisle?
   Begin
    Kurzor.Width:=30; // zmeni na vodorovne
    Kurzor.height:=3;
   end  // je vodorovne
   else
   Begin
    Kurzor.Width:=3; // zmeni na svisle
    Kurzor.height:=30;
   end;
  end;
  If key = 32 then // mezernik - poloz
  Begin
   if Kurzor.width = 30 then // je vodorovne ?
    begin
      if plocha[Kurzor.left div 30,Kurzor.top div 30,2] <> 0 then exit;
   PolozZapalku(Kurzor.left div 30, Kurzor.top div 30,2);

   end
   else
   begin
    if plocha[Kurzor.left div 30,Kurzor.top div 30,1] <> 0 then exit;
    PolozZapalku(Kurzor.left div 30, Kurzor.top div 30,1);
   end;
   ZmenaHrace;
  end;
 KontrolaKoncehry;
 end;
end;

procedure TFormHra.Topten1Click(Sender: TObject);
begin
topten.show;
end;

procedure TFormHra.FormCreate(Sender: TObject);
begin
Hrajese:=false;
end;

procedure TFormHra.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
hrajese:=false;
canclose:=true;
end;

initialization
Hrac1skore:=0;
Hrac2skore:=0;
end.
